import { Aperture } from './Aperture';
import { ApiError } from './ApiError';
import { Camera } from './Camera';
import { CameraBrowser } from './CameraBrowser';
import { CameraFile } from './CameraFile';
import { CameraProperty } from './CameraProperty';
import { Directory } from './Directory';
import { ExposureCompensation } from './ExposureCompensation';
import { FileFormat } from './FileFormat';
import { Flag } from './Flag';
import { ImageQuality } from './ImageQuality';
import { ISOSensitivity } from './ISOSensitivity';
import { ObjectEvent } from './ObjectEvent';
import { Option } from './Option';
import { OutputDevice } from './OutputDevice';
import { ShutterSpeed } from './ShutterSpeed';
import { StateEvent } from './StateEvent';
import { TimeZone } from './TimeZone';
import { Volume } from './Volume';
export * from './Aperture';
export * from './ApiError';
export * from './Camera';
export * from './CameraBrowser';
export * from './CameraFile';
export * from './CameraProperty';
export * from './Directory';
export * from './ExposureCompensation';
export * from './FileFormat';
export * from './Flag';
export * from './ImageQuality';
export * from './ISOSensitivity';
export * from './ObjectEvent';
export * from './Option';
export * from './OutputDevice';
export * from './ShutterSpeed';
export * from './StateEvent';
export * from './TimeZone';
export * from './Volume';
export declare const watchCameras: (timeout?: number) => (() => void);
export declare const cameraBrowser: CameraBrowser;
declare const CameraApi: {
    Aperture: typeof Aperture;
    ApiError: typeof ApiError;
    Camera: typeof Camera;
    CameraBrowser: typeof CameraBrowser;
    CameraFile: typeof CameraFile;
    CameraProperty: typeof CameraProperty;
    Directory: typeof Directory;
    ExposureCompensation: typeof ExposureCompensation;
    FileFormat: typeof FileFormat;
    Flag: typeof Flag;
    ImageQuality: typeof ImageQuality;
    ISOSensitivity: typeof ISOSensitivity;
    ObjectEvent: typeof ObjectEvent;
    Option: typeof Option;
    OutputDevice: typeof OutputDevice;
    ShutterSpeed: typeof ShutterSpeed;
    StateEvent: typeof StateEvent;
    TimeZone: typeof TimeZone;
    Volume: typeof Volume;
    cameraBrowser: CameraBrowser;
    watchCameras: (timeout?: number) => (() => void);
};
export default CameraApi;
